/*
 * CastingCpp example 
 * by hackervalley@free.fr
 * http://hackervalley.free.fr
 * May 2004
 * this program is licensed under the GPL.
 *
 * g++ -Wall -o castingcpp CastingCpp.cc 
 *
 */

#include <iostream>

using namespace std;

/* const_cast */

int
increment (int &i)
{
	i++;
	return i;
}

void
display (const int &i)
{
	int t;
	t = increment (const_cast < int &>(i));
	cout << t << endl;
}

/* dynamic_cast */
class Shape
{
	public:
	Shape ():id(0){};
	int GetId(){return id;}
	private :
		int id;
};

class Vertex:public Shape
{
	public:
	Vertex (): Shape(){};
};

int
main ()
{

	/* static_cast */
	int students = 302;
	int numberOfClasses = 12;
	double rate = static_cast < double >(students) / numberOfClasses;

	cout << "Rate : " << rate << endl;

	/* const_cast */
	const int i = 1;
	display (i);

	/* dynamic_cast */
	
	/* reinterpret_cast */
	
	return 0;
}
